#!/usr/bin/python

# Originally by tmbinc, hacked to death by noggie

import sys, os, struct

if len(sys.argv) < 3:
	raise "please give NFI file and directory as arguments!"
	
file = open(sys.argv[1], "r")
directory = sys.argv[2]
os.mkdir(directory, 0777);
header = file.read(32)

if header[:4] != "NFI1":
	print "old NFI format detected!"
	machine_type = "dm7020"
	file.seek(0)
else:
	machine_type = header[4:4+header[4:].find("\0")]

endianess = {"dm7025": "1234", "dm7020": "4321"}

print "machine type:", machine_type

(total_size, ) = struct.unpack("!L", file.read(4))

p = 0
while file.tell() < total_size:
	(size, ) = struct.unpack("!L", file.read(4))
	
	output_names = {1: "secondstage.gz", 2: "boot", 3: "root"}
	if p not in output_names:
		file.seek(size, 1)
	else:
		print "extracting", output_names[p]
		output_filename = directory + "/" + output_names[p];
		if p != 1:
			output_filename += ".jffs2" 
		output_directory = directory + "/" + output_names[p]
		output = open(output_filename, "wb")
		for sector in range(size / 528):
			d = file.read(528)
			output.write(d[:512])
		output.close()
		if p != 1:
			print "unpacking", p, "(ignore errors about mknod, chown)"
			if os.system("./dump --no-devtab --two-pass %s %s %s" % (output_filename, output_directory, endianess[machine_type])):
				raise "unpacking jffs2 failed!"
			print "ok"
			os.unlink(output_filename)
		
	p += 1


#a = open(directory + "/" + "boot/autorun.bat", "wb")
#a.write("/cf/bootlogo.elf\n")
#a.write("/cf/vmlinux.gz root=/dev/hdc2 console=ttyS0,115200 rw\n")
#a.close()
